#define _CRT_SECURE_NO_DEPRECATE
#include <iostream>
#include <string>
#include <vector>
#include <sstream>
#include <ctime>
#include <queue>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <math.h>
#include <stack>
#include <deque>
#include <numeric>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <bitset>

#define SEED 1336
#define MAXSZ 255
#define SQSZ 4
double TIMEBOMB = 14.1f;
int CODE(int X, int Y) {return ((X)+MAXSZ*(Y));}

#define all(v) v.begin(),v.end()
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
const ld epsylon = 1e-9;
typedef unsigned int ui;
inline long double get_time(){   
	return (long double)clock()/CLOCKS_PER_SEC;
};
ld start_time,end_time;

int h, w, k;
int ops;
int r1[MAXSZ][MAXSZ], r2[MAXSZ][MAXSZ], 
	g1[MAXSZ][MAXSZ], g2[MAXSZ][MAXSZ],
	b1[MAXSZ][MAXSZ], b2[MAXSZ][MAXSZ];


struct result_struct {
	result_struct(int x1, int y1, int x2, int y2, int n, int m) :
x1(x1), y1(y1), x2(x2),
	y2(y2),	n(n), m(m) {}

int x1, y1, x2, y2, n, m;
};

vector <result_struct> result_vec;

//FOR NOW WORK ONLY WITH SQUARES SQSZxSQSZ
struct square {
	square(int x=-1, int y=-1, int diff=-1) : x(x), y(y), diff(diff) {}
	int x, y, diff;
	 
	bool operator < (const square & oth) const {
		if (diff == oth.diff)
			return CODE(x, y) < CODE(oth.x, oth.y);
		return diff < oth.diff;
	}
};

int sqr(int x){return x*x;}

void populate_color(int  color[255][255]) {
	for (int i = 0; i < h; ++i) 
		for (int j = 0; j < w; ++j) 
			scanf("%d", &color[i][j]);
}

void read_inp() {
	scanf("%d %d %d", &h, &w, &k);
	populate_color(r1); populate_color(g1); populate_color(b1);
	populate_color(r2); populate_color(g2); populate_color(b2);
}

map <int, square> squares_by_coords;
pair <int, int> DECODE(int i) { return make_pair(i%MAXSZ, i/MAXSZ);}

int calc_diff_for_square(int sqare_coded_coords) {
	pair<int, int> place_of_square = DECODE(sqare_coded_coords);
	int x = place_of_square.first;
	int y = place_of_square.second;
	int diff = 0;
	for (int i = 0; i < SQSZ; ++i)
		for (int j = 0; j < SQSZ; ++j)
			diff += sqr(r1[x+i][y+j]-r2[x+i][y+j]) 
			+ sqr(g1[x+i][y+j]-g2[x+i][y+j])
			+ sqr(b1[x+i][y+j]-b2[x+i][y+j]);
	return diff;
}

int calc_diff_for_square(int x, int y) {
	int diff = 0;
	for (int i = 0; i < SQSZ; ++i)
		for (int j = 0; j < SQSZ; ++j)
			diff += sqr(r1[x+i][y+j]-r2[x+i][y+j]) 
			+ sqr(g1[x+i][y+j]-g2[x+i][y+j])
			+ sqr(b1[x+i][y+j]-b2[x+i][y+j]);
	return diff;
}

//CALL ONLY ONCE IN SOLVE
void make_square_map() {
	for (int i = 0; i < h-SQSZ; i+=SQSZ)
		for (int j = 0; j < w-SQSZ; j+=SQSZ) 
			squares_by_coords[CODE(i,j)]=square(i,j,calc_diff_for_square(i, j));
}

int calc_fusion(square& first, int x2, int y2) {

	int diff = 0;

	for (int i = 0; i < SQSZ; ++i)  {
		for (int j  = 0; j < SQSZ; ++j) {
			int newr = (r1[first.x+i][first.y+j] + r1[x2+i][y2+j])/2;
			int newg = (g1[first.x+i][first.y+j] + g1[x2+i][y2+j])/2;
			int newb = (b1[first.x+i][first.y+j] + b1[x2+i][y2+j])/2;
			diff += sqr(newr - r2[first.x+i][first.y+i])
				+ sqr(newg - g2[first.x+i][first.y+i])
				+ sqr(newb - b2[first.x+i][first.y+i]);
		}
	}
	return first.diff - diff;
}

bool fusion(int f, int s, int val) {
	if (ops++ >= k) return false;
	int x1 = squares_by_coords[f].x;
	int y1 = squares_by_coords[f].y;
	int x2 = squares_by_coords[s].x;
	int y2 = squares_by_coords[s].y;

	for (int i = 0; i < SQSZ; ++i) {
		for (int j = 0; j < SQSZ; ++j) 
		{
			int newr = (r1[x1+i][y1+j] + r1[x2+i][y2+j])/2;
			int newg = (g1[x1+i][y1+j] + g1[x2+i][y2+j])/2;
			int newb = (b1[x1+i][y1+j] + b1[x2+i][y2+j])/2;
			r1[x1+i][y1+j] = newr;
			g1[x1+i][y1+j] = newg;
			b1[x1+i][y1+j] = newb;
			squares_by_coords[f].diff=val;
		} 
	}
	result_vec.push_back(result_struct(x1,y1,x2,y2,SQSZ,SQSZ));
	return true;
}

void solve() {
	ops = 0;
	make_square_map();
	priority_queue<square> first_pq;

	//MAKE PRIORITY QUEUE WITH SQUARES (FIRST SQUARE WITH GREATEST DIFF)
	for (map<int, square>::const_iterator it = squares_by_coords.begin();
		it != squares_by_coords.end(); ++it) {
			first_pq.push(it->second);
	}

	while (get_time() - start_time < TIMEBOMB) {
		priority_queue<square> new_pq;
		while (!first_pq.empty()) {
			if (get_time() - start_time >= TIMEBOMB) return;
			square biggest = first_pq.top();
			first_pq.pop();

			int best_place = -1;
			int best_val = -1;
			for (map<int, square>::const_iterator it = squares_by_coords.begin(); it != squares_by_coords.end(); ++it) {
				if (it->first != CODE(biggest.x,biggest.y)) {
					int fus_res = calc_fusion(biggest, it->second.x, it->second.y);
					if (fus_res > best_val) {
						if (it->second.x == 125 && it->second.y == 109) {							
							cerr <<"";
						}
						best_val = fus_res;
						best_place = it->first;
					}
				}
			}
			if (best_val > 0) {
				bool ok = fusion(CODE(biggest.x, biggest.y), best_place, best_val);
				if (!ok) return;
				new_pq.push(squares_by_coords[CODE(biggest.x, biggest.y)]);
			}
		}
		first_pq = new_pq;
		while (!new_pq.empty()) {new_pq.pop();}
	}
}

int main()
{
	srand(SEED);
	freopen("transformation.in","r",stdin);
	freopen("transformation.out","w",stdout);
	start_time = get_time();
	//program

	read_inp();
	solve();
	printf("%d\n", result_vec.size());
	for (int i = 0; i < result_vec.size(); ++i) {
		printf("%d %d %d %d %d %d\n", result_vec[i].x1,
			result_vec[i].y1, 
			result_vec[i].x2,
			result_vec[i].y2,
			result_vec[i].n,
			result_vec[i].m);
	}

	//end program
	end_time=get_time()-start_time;
	return 0;
}




